﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.31
@EndOfDesignText@




Sub Process_Globals
	Private bc As ByteConverter
	Private CR() As Byte = Array As Byte(13)
	Public busy As Boolean
	Public busyRele As Boolean
	Private messageToSend(160) As Byte
	Private SMSSlot(4) As Byte
	Private retryEmptyMessages As Byte

	
	'*********************************************
	Private SIM800L_RX As Pin'     27
	Private SIM800L_TX    As Pin'  26
	Private SIM800L_PWRKEY As Pin' 4
	Private SIM800L_RST    As Pin '5
	Private SIM800L_POWER As Pin' 23
	'Private Serial2 As Stream


Public comandoAT As Int
End Sub


Sub setupModem

	'restEM_RST
	' Keep reset high
	SIM800L_RST.Initialize(5,SIM800L_RST.MODE_OUTPUT)
	SIM800L_RST.digitalWrite(True)

	SIM800L_PWRKEY.Initialize(4, SIM800L_PWRKEY.MODE_OUTPUT)
	'SIM800L_PWRKEY.digitalWrite(True)
	SIM800L_POWER.Initialize(23, SIM800L_POWER.MODE_OUTPUT)
  

	' Turn on the Modem Power first
	SIM800L_POWER.DigitalWrite(True)
   

	' Pull down PWRKEY For more than 1 second according To manual requirements
	SIM800L_PWRKEY.DigitalWrite(True)
	Delay(100)
	SIM800L_PWRKEY.DigitalWrite(False)
	Delay(1000)
	SIM800L_PWRKEY.DigitalWrite(True)

End Sub


'*************************************************************************************
'RECIBIR DATOS DEL MODEM
Sub datosRecibidos (Buffer() As Byte)
	'Log(bc.HexFromBytes(Buffer))
	Log("SIM800L-> ", Buffer)
	busy = False
	
			
	
	Select True
		
		Case bc.IndexOf(Buffer, "+CREG:") > -1
			CheckRegistradoResult(Buffer)
		Case bc.IndexOf(Buffer, "RING") > -1
			If busyRele=False Then
			Ring(Buffer)
			End If
		Case bc.IndexOf(Buffer, ">") > -1
			SendSMSParte2' enviar cuerpo del mensaje
'		Case bc.IndexOf(Buffer, "AT+CMGS") > -1
'			SendSMSPart2
			'Log("Cuerpo2")
		Case bc.IndexOf(Buffer, "+CMGS:") > -1
			SendSMSPart3'envio correcto
		Case bc.IndexOf(Buffer, "+CMTI:") > -1
			SMSNuevo(Buffer)'llegó un SMS
		Case bc.IndexOf(Buffer, "+CMGR:") > -1
			SMSLeer(Buffer)'leer el SMS que llegó
		Case bc.IndexOf(Buffer, "+CMGF:") > -1
			Log("Modo Texto OK")
		Case Else
			Log("ningun comando")
			'Log(Buffer)
	End Select
	
End Sub

public Sub Astream_Error
	
End Sub
Public Sub CheckRegistrado
	SendCommand("AT+CREG?", True)
End Sub

Public Sub HabilitarSMSModoTexto As Boolean
	Delay(100)
	Return SendCommand("AT+CMGF=1", False)
	
End Sub
Public Sub HabilitarSMSEventos As Boolean
	Delay(100)
	Return SendCommand("AT+CNMI=2,1", False)
End Sub

'PhoneNumber - should start with + and include country code.
Public Sub Marcar (PhoneNumber() As Byte) As Boolean
	If busy Then Return False
	busy = True
	Main.astream0.Write("ATD").Write(PhoneNumber).Write(";").Write(CR)
	Return True
End Sub

Public Sub Colgar  As Boolean
	If busy Then Return False
	busy = True
	Main.astream0.Write("ATH").Write(CR)
	Return True
End Sub

Public Sub Hangup As Boolean
	Return SendCommand("ATA", False)
End Sub

Private Sub SendCommand1 (cmd() As Byte, ResponseExpected As Boolean) As Boolean
	If busy Then Return False
	busy = ResponseExpected
	Main.astream0.Write(cmd).Write(CR)
	Return True
End Sub
Private Sub SendCommand (cmd() As Byte, ResponseExpected As Boolean) As Boolean
	
	Main.astream0.Write(cmd).Write(CR)
	Return True
End Sub

'PhoneNumber - should start with + and include country code.
Public Sub SendSMS(PhoneNumber() As Byte, message() As Byte) As Boolean
	If busy Then Return False
	busy = True
	Main.astream0.Write("AT+CMGS=""").Write(PhoneNumber).Write("""").Write(CR)
	'copy the message to the global variable
	bc.ArrayCopy(message, messageToSend)
	Return True
End Sub

Private Sub SendSMSParte2
	busy = True
	Log("CUerpo")
	Main.astream0.Write(messageToSend).Write(Array As Byte(0x1a))
End Sub

Private Sub SendSMSPart3
	Log("Message was sent successfully")
End Sub



Private Sub CheckRegistradoResult (buffer() As Byte)
	If bc.IndexOf(buffer, "+CREG: 0,1") > -1 Or bc.IndexOf(buffer, "+CREG: 0,5") > -1 Then
		Log("Registrado")
		'HabilitarSMSEventos' habilitar eventos llegada de mensajes
	Else
		Log("Not registered")
	End If
End Sub

Private Sub SMSNuevo(buffer() As Byte)
	'Log("buffer: ", buffer)
	Dim i As Int = bc.IndexOf(buffer, ",")
	Dim slot() As Byte = bc.SubString(buffer, i + 1)
	bc.ArrayCopy(slot, SMSSlot)
	Log("SMS received, slot = ", SMSSlot)
	retryEmptyMessages = 0
	Delay(200)
	Main.astream0.Write("AT+CMGR=").Write(slot).Write(CR)
	busy = True
End Sub

Private Sub SMSLeer(Buffer() As Byte)
	busy = True
	Dim afterCMGR As Boolean = False
	Dim emptyMessage As Boolean = True
	'Log("buffer: ", Buffer)
	For Each line() As Byte In bc.Split(Buffer, Array As Byte(13, 10))
		If afterCMGR Then
			If line.Length = 0 Or bc.StartsWith(line, "OK") Then Continue
			Log("Msg: ", line)
			If emptyMessage Then
				'Main.procesarSMS(line)
				emptyMessage = False
			End If
		Else If bc.StartsWith(line, "+CMGR") Then
			Dim counter As Int = 0
			For Each s() As Byte In bc.Split(line, """")
				If counter = 3 Then
					Log("From: ", s)
				Else If counter = 7 Then
					Log("Date: ", s)
				End If
				counter = counter + 1
			Next
			afterCMGR = True
		End If
	Next
	If emptyMessage And retryEmptyMessages < 3 Then
		retryEmptyMessages = retryEmptyMessages + 1
		Log("Intentando leer el mensaje nuevamente.")
		Delay(200)
		Main.astream0.Write("AT+CMGR=").Write(SMSSlot).Write(CR)
	Else
		'borrar el SMS
		Main.astream0.Write("AT+CMGD=").Write(SMSSlot).Write(CR)
	End If
End Sub

Private Sub Ring(Buffer() As Byte)
	Log("buffer: ", Buffer)
	Dim clip() As Byte = "+CLIP: """
	Dim callingNumber() As Byte = "unknown"
	Dim i1 As Int = bc.IndexOf(Buffer, clip)
	If i1 > -1 Then
		Dim i2 As Int = bc.IndexOf2(Buffer, """", i1 + clip.Length)
		If i2 > -1 Then
			callingNumber = bc.SubString2(Buffer, i1 + clip.Length, i2)
		End If
	End If
	''''''''''Main.procesarLlamada(callingNumber)
	Log("Ring... Number: ", callingNumber)
	'hangup up the call
	'Hangup
End Sub


Private Sub WriteBytes(raf As RandomAccessFile, Data() As Byte)
	raf.WriteBytes(Data, 0, Data.Length, raf.CurrentPosition)
End Sub
